#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TorpedoRankType.h"
std::auto_ptr<Fish_TorpedoRankType> Fish_TorpedoRankType::msSingleton(nullptr);

int Fish_TorpedoRankType::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TorpedoRankTypeData* Fish_TorpedoRankType::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TorpedoRankTypeData>& Fish_TorpedoRankType::GetMapData()
{
	return mMapData;
}

void Fish_TorpedoRankType::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TorpedoRankType.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TorpedoRankTypeData data;
		data.mID = element->IntAttribute("ID");
		data.mRankType = element->IntAttribute("RankType");
		{
			const char* NoticeValue = element->Attribute("NoticeValue");
			std::vector<std::string> vecNoticeValue;
			boost::split(vecNoticeValue, NoticeValue, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNoticeValue.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNoticeValue[i].c_str(), &temp))
				{
					data.mNoticeValue.push_back(temp);
				}
			}
		}
		{
			const char* Limit = element->Attribute("Limit");
			std::vector<std::string> vecLimit;
			boost::split(vecLimit, Limit, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecLimit.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecLimit[i].c_str(), &temp))
				{
					data.mLimit.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TorpedoRankType Loaded. Load Data:%u", mMapData.size());
}

void Fish_TorpedoRankType::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TorpedoRankType");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TorpedoRankType");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TorpedoRankTypeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RankType", data.mRankType);
		LuaCfgHelper::readVectorInt(L, "NoticeValue", data.mNoticeValue);
		LuaCfgHelper::readVectorInt(L, "Limit", data.mLimit);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TorpedoRankType Loaded. Load Data:%u", mMapData.size());
}

void Fish_TorpedoRankType::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TorpedoRankType* Fish_TorpedoRankType::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TorpedoRankType());
	}
	return msSingleton.get();
}

void Fish_TorpedoRankType::Release()
{
	msSingleton.reset(nullptr);
}
